<?php
if (!defined('__TYPECHO_ROOT_DIR__')) exit;

/**
 * 主题设置
 * @author NatLiu
 * @date   2018-01-24T14:10:44+0800
 * @param  [type]                   $form [description]
 * @return [type]                         [description]
 */
function themeConfig($form) {
    $logoUrl = new Typecho_Widget_Helper_Form_Element_Text('logoUrl', NULL, 'https://blog.vircloud.net/usr/themes/armx/img/header-logo.png', _t('站点 LOGO 地址'), _t('在这里填入一个图片 URL 地址, 用于网站头部 LOGO, 尺寸112x55  （注：也可修改主题img/bg.png文件修改logo）'));
    $form->addInput($logoUrl);

    $switchEnable = new Typecho_Widget_Helper_Form_Element_Checkbox('switchEnable', 
    array(
        'ShowLoginRegister' => _t('显示登录注册模块'),
        'enablePjax' => _t('启用全站 Pjax')
    ),
    array('enablePjax'), _t('主题功能开关'));
    
    $form->addInput($switchEnable->multiMode());

    $srcAddress = new Typecho_Widget_Helper_Form_Element_Text('src_add', NULL, '/usr/uploads/', _t('CDN 替换前地址'), _t('即附件存放目录'));
    $form->addInput($srcAddress);
    $cdnAddress = new Typecho_Widget_Helper_Form_Element_Text('cdn_add', NULL, NULL , _t('CDN 完整地址'), _t('即 CDN 存储地址<br />比如附件存放位置是 https://yourblog/uploads/2018/05/1.png，CDN 访问是 https://cdn.com/uploads/1.png，那么替换前地址就是 https://yourblog/uploads/2018/05/，替换后就是 https://cdn.com/uploads/'));
    $form->addInput($cdnAddress);
  
    $isDonate = new Typecho_Widget_Helper_Form_Element_Radio('isdonate',
        array(
            '0' => _t('禁用'),
            '1' => _t('启用')
        ),
        '1',_t('是否启用赞赏功能'),_t("默认启用（需启用 Like 插件）")
    );    
    $form->addInput($isDonate);
  
    $donateImg =  new Typecho_Widget_Helper_Form_Element_Text('donate_img', NULL, 'https://blog.vircloud.net/usr/themes/handsome/img/weixinpay.png', _t('支付二维码'), _t('建议大小 250x250'));
     $form->addInput($donateImg);
  
    $isAbout = new Typecho_Widget_Helper_Form_Element_Radio('isabout',
        array(
            '0' => _t('禁用'),
            '1' => _t('启用')
        ),
        '1',_t('是否启用侧栏相关文章'),_t("默认启用")
    );    
    $form->addInput($isAbout);
  
    $isRecommend = new Typecho_Widget_Helper_Form_Element_Radio('isrecommend',
        array(
            '0' => _t('禁用'),
            '1' => _t('启用')
        ),
        '1',_t('是否启用侧栏随机文章'),_t("默认启用")
    );    
    $form->addInput($isRecommend);
  
    $isStat = new Typecho_Widget_Helper_Form_Element_Radio('isstat',
        array(
            '0' => _t('禁用'),
            '1' => _t('启用')
        ),
        '1',_t('是否启用侧栏网站统计'),_t("默认启用")
    );    
    $form->addInput($isStat);
  
    $isTags = new Typecho_Widget_Helper_Form_Element_Radio('istags',
        array(
            '0' => _t('禁用'),
            '1' => _t('启用')
        ),
        '1',_t('是否启用侧栏热门标签'),_t("默认启用")
    );    
    $form->addInput($isTags);
  

}


/*
 *首页缩略图
*/

function the_index_thumbnail($post)
{
  if(isset($post->fields->thumb2)){
    $ctu = $post->fields->thumb2; 
  }
  else{
    $ctu = '/usr/themes/armx/img/thumb.jpg';
  }
  echo $ctu;
}

/**
 * 文章缩略
 * @author NatLiu
 * @date   2018-01-24T14:00:22+0800
 * @param  [type]                   $post    [description]
 * @param  string                   $default [description]
 * @return [type]                            [description]
 */
function the_post_thumbnail($post, $default = '')
{
  echo get_post_thumbnail($post, $default);
}

/**
 * 获取文章缩略图
 * @author NatLiu
 * @date   2018-01-24T14:00:30+0800
 * @param  [type]                   $post    [description]
 * @param  string                   $default [description]
 * @return [type]                            [description]
 */
function get_post_thumbnail($post, $default = '')
{
    $thumb = get_thumbnail_src($post->cid);
    $default = empty($default) ? '/usr/themes/armx/img/thumb.jpg' : $default;
    if(empty($thumb) && preg_match('/src=["\']([^"\']+)["\']/', $post->content, $matches)){
        $thumb = $matches[1];
    }
    return empty($thumb) ? $default : $thumb;
}

/**
 * 留空
 * @author NatLiu
 * @date   2018-01-24T14:00:43+0800
 * @param  string                   $message   [description]
 * @param  string                   $className [description]
 * @return [type]                              [description]
 */
function empty_message( $message = '', $className = '' )
{
    $class = 'empty-placeholder';
    if(!empty($className)){
        $class .= ' '.$className;
    }
    echo '<div class="'.$class.'"><div class="placeholder-bg"></div><div class="placeholder-content">'.$message.'</div></div>';
}


/**
 * 评论输出
 * @author NatLiu
 * @date   2018-01-24T14:00:59+0800
 * @param  [type]                   $that                 [description]
 * @param  [type]                   $singleCommentOptions [description]
 * @return [type]                                         [description]
 */
function threadedComments($that, $singleCommentOptions)
{
    $domain = trim($_SERVER['HTTP_HOST']);
    $commentClass = '';
        if ($that->authorId) {
            if ($that->authorId == $that->ownerId) {
                $commentClass .= ' comment-by-author';
            } else {
                $commentClass .= ' comment-by-user';
            }
        }
?>
<li itemscope itemtype="http://schema.org/UserComments" id="<?php $that->theId(); ?>" class="comment-item<?php
    if ($that->levels > 0) {
        echo ' comment-child';
        $that->levelsAlt(' comment-level-odd', ' comment-level-even');
    } else {
        echo ' comment-parent';
    }
    $that->alt(' comment-odd', ' comment-even');
    echo $commentClass;
?>">
    <div class="comment-author" itemprop="creator" itemscope itemtype="http://schema.org/Person">
       <?php $that->gravatar($singleCommentOptions->avatarSize, $singleCommentOptions->defaultAvatar); ?>
    </div>
<div class="comment-body">
    <div class="comment-meta">
        <strong class="author-name"><?php if(isset($that->url)){
echo "<a href=\"//$domain/ext/link/?url=$that->url\" target=\"_blank\" rel=\"external nofollow\">$that->author</a>";} else{ echo $that->author;} ?></strong>
        <p><a class="comment-date" href="<?php $that->permalink(); ?>"><time itemprop="commentTime" datetime="<?php $that->date('Y-m-d H:i:s'); ?>"><?php $singleCommentOptions->beforeDate();
        $that->dateWord();
        $singleCommentOptions->afterDate(); ?></time></a>
        <?php if ('waiting' == $that->status) { ?>
        <em class="comment-awaiting-moderation"><?php $singleCommentOptions->commentStatus(); ?></em>
        <?php } ?>
        </p>
    </div>
    <div class="comment-content" itemprop="commentText">
    <?php $that->content(); ?>
    </div>
    <div class="comment-reply" id="comment-reply-<?php echo $that->coid;?>">
        <a data-commentid="<?php echo $that->coid;?>" data-respondid="<?php echo $that->parameter->respondId;?>" onclick="return TypechoComment.reply('<?php echo
                    $that->theId; ?>', '<?php echo $that->coid;?>');">回复</a>
    </div>
</div>
<div class="clearfix" id="comment-clear-<?php echo $that->coid;?>"></div>
    <?php if ($that->children) { ?>
    <div class="comment-children" itemprop="discusses">
        <?php $that->threadedComments(); ?>
    </div>
    <?php } ?>
</li>
<?php
}

/**
 * 获取第三方登录态
 * @author NatLiu
 * @date   2018-01-24T14:01:06+0800
 * @return [type]                   [description]
 */
function getAuth()
{
    if (empty(Typecho_Cookie::get('__typecho_oauth_openid'))) {
        return false;
    }
    return array(
            'openid' => Typecho_Cookie::get('__typecho_oauth_openid'),
            'nickname' => Typecho_Cookie::get('__typecho_oauth_nickname'),
            'avatar' => Typecho_Cookie::get('__typecho_oauth_avatar')
        );
}

/**
 * 显示登录人员
 * @author NatLiu
 * @date   2018-01-24T14:01:19+0800
 * @param  [type]                   $user    [description]
 * @param  [type]                   $options [description]
 * @param  [type]                   $request [description]
 * @return [type]                            [description]
 */
function the_user($user, $options, $request)
{
    $avatar = Typecho_Common::gravatarUrl($user->mail, 36, 'X', 'mm', $request->isSecure());
    $auth = getAuth();
    $profile = $options->profileUrl;
    if ($auth) {
        $avatar = preg_replace('/^http(s)?:\/\//', 'https://', $auth['avatar']);
    }
?>
    <div class="user-tools" id="user-tools">
        <img src="<?php echo $avatar;?>" />
    <div class="user-menu" id="user-menu">
        <?php if($auth):?>
        <a class="user-item" data-action="dialog.register_bind" href="javascript:;">绑定账号</a>
        <a class="user-item" data-action="oauth.logout">退出登录</a>
        <?php elseif( $user->hasLogin() ):?>
        <a class="user-item" data-no-instant target="_blank" href="<?php echo $profile;?>">个人中心</a>
        <a class="user-item" data-action="logout">退出登录</a>
        <?php else:?>
        <a class="user-item" data-action="dialog.login">登录</a>
        <?php if($options->allowRegister):?>
        <a class="user-item" data-action="dialog.register">注册</a>
        <?php endif;?>
        <?php endif;?>
    </div>
    </div>
<?php
}

/**
 * 获取文章分类
 * @author NatLiu
 * @date   2018-01-24T14:01:28+0800
 * @param  [type]                   $post [description]
 * @return [type]                         [description]
 */
function the_post_cat($post){
  $type = $post->fields->type;
  $category = $post->categories[0];
   if(isset($type)){
     if($type == 'jiaocheng') { $type = '教程'; }
     else if ($type == 'youhui') { $type =  "优惠"; }
     else if ($type == 'fuli') { $type =  "福利"; }
     else if ($type == 'jingyan') { $type =  "经验"; }
     else { $type =  "生活"; } }
   else { $type =  "生活"; }
   echo "<a class=\"post-cat\" href=\"".$category['permalink']."\"><span>$type</span></a>";
}

/**
 * 搜索关键词高亮
 * @author NatLiu
 * @date   2018-01-24T14:01:58+0800
 * @param  string                   $keyword [description]
 * @param  string                   $text    [description]
 * @return [type]                            [description]
 */
function highlightSearch($keyword = '', $text = '')
{
    if ($keyword==='') {
        return $text;
    }
    $text = preg_replace_callback('/'.preg_quote($keyword).'/i', function ($matches)
    {
       return "<strong class=\"search-keyword\">$matches[0]</strong>";
    }, $text);
    return $text;
}


//文章阅读次数含cookie
function get_post_view($archive)
{
    $cid    = $archive->cid;
    $db     = Typecho_Db::get();
    $prefix = $db->getPrefix();
    if (!array_key_exists('views', $db->fetchRow($db->select()->from('table.contents')))) {
        $db->query('ALTER TABLE `' . $prefix . 'contents` ADD `views` INT(10) DEFAULT 0;');
        echo 0;
        return;
    }
    $row = $db->fetchRow($db->select('views')->from('table.contents')->where('cid = ?', $cid));
    if ($archive->is('single')) {
 $views = Typecho_Cookie::get('extend_contents_views');
        if(empty($views)){
            $views = array();
        }else{
            $views = explode(',', $views);
        }
if(!in_array($cid,$views)){
       $db->query($db->update('table.contents')->rows(array('views' => (int) $row['views'] + 1))->where('cid = ?', $cid));
array_push($views, $cid);
            $views = implode(',', $views);
            Typecho_Cookie::set('extend_contents_views', $views); //记录查看cookie
        }
    }
    echo $row['views'];
}

//最新文章或更新文章
function new_or_update($post)
{
     date_default_timezone_set('PRC');
     $t1 = date('Y-m-d H:i:s',$post->modified);
     $t2 = date('Y-m-d H:i:s');
     $t3 = date('Y-m-d H:i:s',$post->created);
     $diff = (strtotime($t2)-strtotime($t1))/3600;
     $diff2 = (strtotime($t2)-strtotime($t3))/3600;
     if($diff<36){
      echo "<span class=\"zd zdn\">最新</span>";
     }
     if($diff<36 && $diff2>=36){
      echo "<span class=\"zd zdu\">更新</span>";
     }
}

//运行秒数 
function uptime( $uptime = '')
{
   date_default_timezone_set('PRC');
   $t = date('Y-m-d H:i:s');
   $tn = strtotime($t);
   $ts = 1488805872; //2017-3-6 21:11:12
   $cle = $tn - $ts;
    echo $cle;
}

//运行秒数
function uptimed( $uptimed= '')
{
   date_default_timezone_set('PRC');
   $t = date('Y-m-d H:i:s');
   $tn = strtotime($t);
   $ts = 1488805872; //2017-3-6 21:11:12
   $cle = $tn - $ts;
   $cle = floor( $cle / 86400 ); //天
   echo $cle;
}

//随机文章
function theme_random_posts($random){
$defaults = array(
'number' => 6, //输出文章条数
'xformat' => '<li><a href="{permalink}">{title}</a></li>'
);
$db = Typecho_Db::get();
 
$sql = $db->select()->from('table.contents')
->where('status = ?','publish')
->where('type = ?', 'post')
->limit($defaults['number'])
->order('RAND()');
 
$result = $db->fetchAll($sql);
foreach($result as $val){
$val = Typecho_Widget::widget('Widget_Abstract_Contents')->filter($val);
echo '<li class="recent recent-0 redash">
 <a href="' . $val['permalink'] . '" title="' . $val['title'] . '"><span class="recent-title"><i class="fa fa-random likepost"></i> ' . $val['title'] . '</span></a>
            </li>';
}
}

//重新处理文章
function parseContent($obj){
  
    $options = Typecho_Widget::widget('Widget_Options');
    if(!empty($options->src_add) && !empty($options->cdn_add)) {
       $obj->content = str_ireplace($options->src_add,$options->cdn_add,$obj->content);
    }
  
 	preg_match_all('/<a(.*?)href="(.*?)"(.*?)>/',$obj->content,$matches);  //外链处理
	$domain = trim($_SERVER['HTTP_HOST']);
	if($matches){
	  foreach($matches[2] as $val)
             {
		if(strpos($val,'://')!==false && strpos($val,$domain)===false && !preg_match('/\.(jpg|jepg|png|ico|bmp|gif|tiff)/i',$val))
                  {
			  $obj->content=str_replace("href=\"$val\"", "href=\"//".$domain."/ext/link/?url=$val\" target=\"_blank\" rel=\"external nofollow\" ",$obj->content);
		  }
        if(preg_match('/go/i',$val))
                  {
              $obj->content=str_replace("href=\"$val\"", "href=\"//".$domain."/ext/link/?url=https://$domain$val\" target=\"_blank\" rel=\"external nofollow\" ",$obj->content);
                  }
	     }
	}      
  
    echo trim($obj->content);
}

function getIP()
{
    static $realip;
    if (isset($_SERVER)){
        if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])){
           $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
       } else if (isset($_SERVER["HTTP_CLIENT_IP"])) {
           $realip = $_SERVER["HTTP_CLIENT_IP"];
       } else {
           $realip = $_SERVER["REMOTE_ADDR"];
        }
    } else {
        if (getenv("HTTP_X_FORWARDED_FOR")){
            $realip = getenv("HTTP_X_FORWARDED_FOR");
        } else if (getenv("HTTP_CLIENT_IP")) {
            $realip = getenv("HTTP_CLIENT_IP");
        } else {
            $realip = getenv("REMOTE_ADDR");
        }
    }
    return $realip;
}

function getCountry()
{
   $url = "http://ip.taobao.com/service/getIpInfo.php?ip=".getIP();
   $json = json_decode(file_get_contents($url)); 
   $country = $json->{"data"}->{"country_id"}; // 判断国家代码 把需要判断的国家加在下面就行了
  // $countrys = array("RU", "MX"); 
  // if (in_array($country, $countrys)) {
  // 	 $url="https://blog.vircloud.net/40x.html"; 
  // } else{
  //   $url="https://blog.vircloud.net/index.php?true"; 
  // }
   return $country;
}
